#!/usr/bin/env python2
# -*- coding: utf-8 -*-


# Photos promo 2017
from django.core.management.base import NoArgsCommand
from portailuser.models import Ecole
from ldap_inp import LdapEleveAvecPhoto
from gestion.inscriptions.models import recadrage, reduire_taille

import os
from PIL import Image


class Command(NoArgsCommand):
    help = "Photos ENSAT promo 2017"

    def handle_noargs(self, *args, **kwargs):
        main("ensat_2017", 2017)  # promo 2017


def save_photos(rep, promo):
    """Create a Jpeg"""
    for img in os.listdir(rep):
        # givenNameSearch
        # snSearch
        name = img[0:-4]  # supprime '.jpg' de la fin et la lettre du prénom
        print(f"Nom : {name} ({img})…")
        try:
            eleve = LdapEleveAvecPhoto.objects.filter(ecole=Ecole.ensat, uid=name, promo=str(promo))
            if len(eleve) == 1:
                eleve = eleve[0]
            else:
                print("\tPas de correspondance pour le login " + name)

            eleve.jpegPhoto = lire_photo(img, rep)
            eleve.save()
            print("\t→ ok")
        except Exception as e:
            print("\t← Erreur :" + str(e))


#            print "\toups, pas d'élève " + name + ", uid=" + img.split('.jpg')[0]


def lire_photo(ident, rep):
    """Lit la photo ident"""
    photo = Image.open(os.path.join(rep + "/", ident))
    photo = photo.crop(recadrage(photo.size))
    photo = photo.resize(reduire_taille(photo.size, 144), Image.ANTIALIAS)

    return photo


def main(rep, promo):
    """Main"""
    save_photos(rep, promo)


if __name__ == "__main__":
    main("ensat_2017", 2017)
